<?php
/*
Plugin Name: Easy PHP Text Widget
Version: 1.0.0
Plugin URI: http://simple-php-text-widget.wpdevelopment.in/
Description: Extends the functionality of default WordPress text widget making it able to execute and run PHP code effortlessly. Just activate and you are good to go.
Author: Dipak Kumar Pusti
Author URI: http://iamdipak.in/
Text Domain: easy-php-text-widget
License: GPL2

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
* The EasyPHPTextWidget class
*
* @package    WordPress_Plugins
* @subpackage   EasyPHPTextWidget
* @since    1.0.0
*/
class EasyPHPTextWidget {

  /**
  * The EasyPHPTextWidget class constructor
  * initializing required stuff for the plugin
  *
  * PHP 5 Constructor
  *
  * @since    1.0.0
  */
  function __construct() {
    add_filter('widget_text', array(&$this, 'ptw_widget_text'), 99);
  }

  /**
  * Filter the content of text widget to support PHP
  *
  * @since    1.0.0
  */
  function ptw_widget_text( $text ) {

    // Checking current user capability for unfiltered_html
    if( !current_user_can( 'unfiltered_html' ) ) {

      // Sanitize field
      $text = sanitize_text_field( $text );
      return $text;
    }

    // Validating and manipulating text added to widget
    if (strpos($text, '<' . '?') !== false) {
        ob_start();
        eval('?' . '>' . $text);
        $text = ob_get_clean();

        // Returning the final result
        return $text;
    }
  }
}

new EasyPHPTextWidget();